RDKit: RDKit::RDProps Class Reference

| RDKit Open-source cheminformatics and machine learning.

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes | List of all members
RDKit::RDProps Class Reference

`#include <RDProps.h>`

Inheritance diagram for RDKit::RDProps:

## Public Member Functions
| RDProps ()
| RDProps (const RDProps &rhs)
RDProps & | operator= (const RDProps &rhs)
void | clear ()
const Dict & | getDict () const
| gets the underlying Dictionary More...
Dict & | getDict ()
STR_VECT | getPropList (bool includePrivate=true, bool includeComputed=true) const
| returns a list with the names of our `properties` More...
template<typename T >
void | setProp (const std::string &key, T val, bool computed=false) const
| sets a `property` value More...
template<typename T >
void | getProp (const std::string &key, T &res) const
| allows retrieval of a particular property value More...
template<typename T >
T | getProp (const std::string &key) const
template<typename T >
bool | getPropIfPresent (const std::string &key, T &res) const
bool | hasProp (const std::string &key) const
void | clearProp (const std::string &key) const
| clears the value of a `property` More...
void | clearComputedProps () const
| clears all of our `computed` `properties` More...
void | updateProps (const RDProps &source, bool preserveExisting=false)
| update the properties from another More...

## Protected Attributes
Dict | dp_props

## Detailed Description

Definition at line 9 of file RDProps.h.

## Constructor & Destructor Documentation

RDKit::RDProps::RDProps | ( |  | ) |
| inline

Definition at line 17 of file RDProps.h.

RDKit::RDProps::RDProps | ( | const RDProps & | rhs | ) |
| inline

Definition at line 18 of file RDProps.h.

## Member Function Documentation

void RDKit::RDProps::clear | ( |  | ) |
| inline

Definition at line 23 of file RDProps.h.

References RDKit::Dict::reset().

void RDKit::RDProps::clearComputedProps | ( |  | ) | const
| inline

clears all of our `computed` `properties`

Definition at line 140 of file RDProps.h.

References RDKit::Dict::clearVal(), RDKit::detail::computedPropName, getPropIfPresent(), and RDKit::Dict::setVal().

Referenced by RDKit::ROMol::endConformers().

void RDKit::RDProps::clearProp | ( | const std::string & | key | ) | const
| inline

clears the value of a `property`

Notes:

- if no `property` with name `key` exists, a KeyErrorException will be thrown.
- if the `property` is marked as `computed`, it will also be removed from our list of `computedPropertiesThis` is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 127 of file RDProps.h.

References RDKit::Dict::clearVal(), RDKit::detail::computedPropName, getPropIfPresent(), and RDKit::Dict::setVal().

Referenced by RDKit::Atom::setAtomMapNum().

const Dict& RDKit::RDProps::getDict | ( |  | ) | const
| inline

gets the underlying Dictionary

Definition at line 25 of file RDProps.h.

References dp_props.

Referenced by RDKit::streamReadProps(), RDKit::streamWriteProps(), and updateProps().

Dict& RDKit::RDProps::getDict | ( |  | ) |
| inline

Definition at line 26 of file RDProps.h.

References dp_props.

template<typename T >

void RDKit::RDProps::getProp | ( | const std::string & | key,
|  | T & | res
| ) |  | const
| inline

allows retrieval of a particular property value

Parameters

  key | the name under which the `property` should be stored. If a `property` is already stored under this name, it will be replaced.
  res | a reference to the storage location for the value.

Notes:

- if no `property` with name `key` exists, a KeyErrorException will be thrown.
- the `boost::lexical_cast` machinery is used to attempt type conversions. If this fails, a `boost::bad_lexical_cast` exception will be thrown.This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 97 of file RDProps.h.

References RDKit::Dict::getVal().

Referenced by RDKit::Drawing::detail::getAtomSymbolAndOrientation().

template<typename T >

T RDKit::RDProps::getProp | ( | const std::string & | key | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 103 of file RDProps.h.

References RDKit::Dict::getVal().

template<typename T >

bool RDKit::RDProps::getPropIfPresent | ( | const std::string & | key,
|  | T & | res
| ) |  | const
| inline

returns whether or not we have a `property` with name `key` and assigns the value if we do This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 111 of file RDProps.h.

References RDKit::Dict::getValIfPresent().

Referenced by clearComputedProps(), clearProp(), RDKit::Atom::getAtomMapNum(), getPropList(), and setProp().

STR_VECT RDKit::RDProps::getPropList | ( | bool | includePrivate = `true`,
|  | bool | includeComputed = `true`
| ) |  | const
| inline

returns a list with the names of our `properties`

Definition at line 34 of file RDProps.h.

References RDKit::detail::computedPropName, getPropIfPresent(), and RDKit::Dict::keys().

Referenced by RDKit::streamWriteProps().

bool RDKit::RDProps::hasProp | ( | const std::string & | key | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 116 of file RDProps.h.

References RDKit::Dict::hasVal().

Referenced by RDKit::Drawing::detail::getAtomSymbolAndOrientation(), RDKit::queryAtomMissingChiralTag(), and RDKit::Atom::setAtomMapNum().

RDProps& RDKit::RDProps::operator= | ( | const RDProps & | rhs | ) |
| inline

Definition at line 19 of file RDProps.h.

References dp_props.

template<typename T >

void RDKit::RDProps::setProp | ( | const std::string & | key,
|  | T | val,
|  | bool | computed = `false`
| ) |  | const
| inline

sets a `property` value

Parameters

  key | the name under which the `property` should be stored. If a `property` is already stored under this name, it will be replaced.
  val | the value to be stored
  computed | (optional) allows the `property` to be flagged `computed.This` is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 66 of file RDProps.h.

References RDKit::detail::computedPropName, getPropIfPresent(), and RDKit::Dict::setVal().

Referenced by RDKit::Atom::setAtomMapNum().

void RDKit::RDProps::updateProps | ( | const RDProps & | source,
|  | bool | preserveExisting = `false`
| ) |  |
| inline

update the properties from another

Definition at line 154 of file RDProps.h.

References getDict(), and RDKit::Dict::update().

## Member Data Documentation

Dict RDKit::RDProps::dp_props
| mutableprotected

Definition at line 11 of file RDProps.h.

Referenced by RDKit::RWMol::clear(), getDict(), and operator=().

The documentation for this class was generated from the following file:

- RDProps.h